/* 
 * This file is automatically generated.  
 */

/*
 Author: Howie Kaye

 Columbia University Center for Computing Activities, July 1986.
 Copyright (C) 1986, 1987, Trustees of Columbia University in the City
 of New York.  Permission is granted to any individual or institution
 to use, copy, or redistribute this software so long as it is not sold
 for profit, provided this copyright notice is retained.
*/


#define MAJORVERSION 1
#define MINORVERSION 48
#define VERSIONDATE "Fri Jun 17 01:26:02 1988"

/*
 * $Log:	cmver.h,v $
 * Revision 1.51  88/06/17  01:26:03  howie
 * local front ends around system include files.
 * make sure things only get included once
 * 
 * Revision 1.50  88/06/14  19:58:33  chris
 * Fix parsing of ~ or ~user or pathnames with trailing '/''s in
 * directory name parses.
 * 
 * Revision 1.49  88/06/12  13:06:34  chris
 * minor cleanup
 * 
 * Revision 1.48  88/04/29  23:00:05  howie
 * fix some problems in cmd line history.
 * 
 * Revision 1.47  88/04/29  22:12:49  howie
 * Add command line history on ^P and ^N
 * 
 * Revision 1.46  88/04/18  14:45:34  howie
 * make fdbchn use varargs!!!
 * 
 * Revision 1.45  88/04/05  12:43:57  howie
 * add 1987 USA dst rules
 * 
 * Revision 1.44  88/03/25  18:36:05  howie
 * make sure it runs on msdos
 * 
 * Revision 1.43  88/03/23  22:02:29  howie
 * add cmwrp field to cmcsb.  Used for line wrapping.
 * 
 * Revision 1.42  88/03/22  18:44:56  howie
 * add functionality to paragraph parser.   execute commands, and insert
 * the output into the buffer, filter the buffer, and autowrap mode.
 * 
 * Revision 1.41  88/03/21  18:20:21  howie
 * fix bug in cmpara's csb restoral
 * 
 * Revision 1.40  88/03/21  11:33:49  howie
 * fix more tab stop problems
 * 
 * Revision 1.39  88/03/19  18:04:30  howie
 * fix up tab stop problems.
 * clean up state save/restore in cmpara.
 * 
 * Revision 1.38  88/03/16  19:43:11  howie
 * make KEY_IGN == KEY_NOR
 * fix some bugs
 * 
 * Revision 1.37  88/02/22  15:36:05  howie
 * cmnum parse had a problem.
 * 
 * Revision 1.36  88/02/18  18:22:20  howie
 * fix up installation scripts.
 * fix up sysV compatibility
 * 
 * Revision 1.35  88/02/07  02:56:46  howie
 * add completion on TAB.  don't do this if we aren't a terminal, so people
 * can have tabs in take files and indirect files
 * 
 * Revision 1.34  88/02/04  15:13:35  howie
 * fix up memory management in crunch file reader
 * 
 * Revision 1.33  88/02/04  12:09:52  howie
 * use whoami() routine to do ~/...
 * 
 * 
 * Revision 1.32  88/02/03  17:24:03  howie
 * add code for reading "passwd.crunch" files
 * 
 * Revision 1.31  88/02/03  15:36:41  howie
 * add partial completion on keywords
 * 
 * Revision 1.30  87/12/03  17:51:21  howie
 * Add ^T support to stdact
 * 
 * Revision 1.29  87/11/20  19:16:37  howie
 * add async mode for use with select(2).
 * fix bug in Parse Only filenames with ~user in them, when
 * the file didn't exist.
 * 
 * Revision 1.28  87/10/30  12:40:32  howie
 * @indirection shouldn't happen inside comments
 * 
 * Revision 1.27  87/10/30  12:19:43  howie
 * add support for nonblocking reads.  use cmsetbl(), cmclrbl() to
 * set a return point for EWOULDBLOCK errors.
 * 
 * Revision 1.26  87/09/14  18:39:22  howie
 * change the way "." and ".." are handled in file parses.   Allow them
 * to show up whenever the parse does not pertain to a multiple directory 
 * path
 * 
 * Revision 1.25  87/09/14  13:13:18  howie
 * NOUPD and UPDATEONLY flags for username and group parses.
 * These either force, or don't allow updates from a possibly modified
 * group/passwd file
 * 
 * Revision 1.24  87/09/09  15:08:51  howie
 * make quoted string parse put data in pval struct
 * ,
 * 
 * Revision 1.23  87/09/04  20:39:48  howie
 * various fixes to filename parser, and match() call
 * 
 * Revision 1.22  87/09/03  16:52:07  howie
 * in file name parser, follow the PATH specified, when a relative path
 * is specified.  
 * eg if the path has "/a /b /c" in it, and d/e is given as a file, find
 * all occurances of /a/d/e, /b/d/e, and /c/d/e
 * 
 * Revision 1.21  87/08/18  12:58:56  howie
 * add FLD_EMPTY flag to field parse, to not allow empty fields
 * add TOK_WAK flag to allow wakeups on field parses without a termination
 *  character (useful for single char tokens).
 * 
 * Revision 1.20  87/08/07  16:58:09  howie
 * FLD_EMPTY flag for not allowing empty field
 * TOK_WAK flag for allowing tokens to terminate without a termination char
 * 
 * Revision 1.19  87/06/28  13:54:10  howie
 * stack indirect files
 * error messages for stacks
 * cm_set_ind call in cmmisc.c
 * 
 * Revision 1.18  87/06/26  19:05:00  howie
 * Change filelist.c to check for modifications to directories when
 * checking if the path needs to be searched again
 * 
 * Some corrections to sysv junk
 * add cm_set_ind call to turn indirection on or off.
 * 
 * Revision 1.17  87/06/24  22:56:13  howie
 * Add system V support
 * 
 * Revision 1.16  87/06/18  15:49:20  howie
 * fix up endif's -- no more endif foo -- now foo is inside a comment
 * make comments end at the end of the line inside an indirection.
 * 
 * Revision 1.15  87/06/17  13:17:24  howie
 * Add @indirection
 * change keyword structure to use a (keyval) as the return value.
 * 
 * Revision 1.14  87/05/19  15:20:39  howie
 * use vprintf's from cmxprintf
 * 
 * Revision 1.13  87/05/18  13:10:39  howie
 * change handling of NULL in various places, to avoid possible
 * NULL dereferences.  This breaks on SUNS (and is bad anyway).
 * Thanks to Maurice Wuts at USC for the sun port.
 * 
 * Revision 1.12  87/05/11  18:15:48  howie
 * cmfil: don't search directories on null input
 * filelist: fix handling of S_IFDIR stat flag.
 * 
 * Revision 1.11  87/05/11  13:05:47  fuat
 * in checkact, only call action routine if an action character AND
 * the action routine is non NULL.
 * 
 * Revision 1.10  87/05/11  11:51:54  fuat
 * fix redispact in cmpara to handle wrapped lines
 * 
 * Revision 1.9  87/05/07  19:38:35  howie
 * change the usage for defaults at the beginning of a line.
 * also fix up full/partial completion on defaults
 * 
 * Revision 1.8  87/05/07  13:24:53  howie
 * new datime code.
 * other bug fixes
 * 
 * Revision 1.7  87/04/08  19:41:20  howie
 * add _cmmax field to the CSB.  This is the maximum number of tokens
 * to display when giving help.  If there are more than this, just
 * tell how many there are.
 * Also made CMFIL, CMUSR, CMGRP use this.
 * 
 * Revision 1.6  87/04/08  18:04:13  howie
 * Some bug fixes.
 * fix a bug not allowing escape completion in CMTOK
 * fix bug with KEY_M`NOR flag in CMKEY.  If only one match, not ignored.
 * 
 * Revision 1.5  87/04/05  19:17:15  howie
 * some cosmetic changes.
 * 
 * Revision 1.4  87/04/05  18:14:56  howie
 * Added single character parse module: cmchar.
 * update copyrite notices.
 * add Version module cmversion, and incversion program
 *  to handle automatic version updates.
 * add cmini() function to cmmisc(), to make initialization easier.
 * 
 * Revision 1.4  87/04/05  18:14:56  howie
 * Added single character parse module: cmchar.
 * update copyrite notices.
 * add Version module cmversion, and incversion program
 *  to handle automatic version updates.
 * add cmini() function to cmmisc(), to make initialization easier.
 * 
 * Revision 1.3  87/04/05  17:27:10  howie
 * update copyrite notice.
 * 
 * Revision 1.2  87/04/03  18:27:17  howie
 * Added version numbers
 * 
 */

